/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates the use of toggle gadgets in a radio
box.
***************************************************************/

/* radio_gadget.c */

#include <Xm/Xm.h>
#include <Xm/ToggleBG.h>
#include <Xm/RowColumn.h>

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

Widget toplevel, radio_box, toggles[5];

void changeCB(w,client_data,call_data)
    Widget w;
    int client_data;
    XmAnyCallbackStruct *call_data;
{
    Boolean set;
    Arg al[10];
    int ac;

    ac=0;
    XtSetArg(al[ac], XmNset, &set); ac++;
    XtGetValues(w,al,ac);

    if (set)
        printf("%d turned on\n",client_data);
    else
        printf("%d turned off\n",client_data);
}

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[10];
    int ac;
    int x;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,
        NULL,NULL,0);

    /* create a Radio Box container to hold the toggles */
    ac=0;
    radio_box=XmCreateRadioBox(toplevel,"radio_box",al,ac);
    XtManageChild(radio_box);

    /* create 5 toggles */
    for (x=0; x<5; x++)
    {
        ac=0;
        XtSetArg(al[ac],XmNlabelString,
             XmStringCreate("I'm a toggle", char_set)); ac++;
        toggles[x]=XmCreateToggleButtonGadget(radio_box,"toggle",al,ac);
        XtManageChild(toggles[x]);
        XtAddCallback (toggles[x], XmNvalueChangedCallback, changeCB, x);
    }

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
